# generated by datamodel-codegen:
#   filename:  https://cranfield-university-aedg.github.io/Pages/FLOPS/schemas/output.json
#   timestamp: 2024-06-28T11:55:39+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import BaseModel, Extra, Field, constr


class OutputOptionNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    IOPT: Optional[int] = Field(None, description='TYPE OF PROBLEM             ')
    IANAL: Optional[int] = Field(None, description='ANALYSIS OPTION             ')
    INENG: Optional[int] = Field(None, description='MAIN ENGINE DECK SWITCH     ')
    ITAKOF: Optional[int] = Field(None, description='DETAILED TAKEOFF SWITCH     ')
    ILAND: Optional[int] = Field(None, description='DETAILED LANDING SWITCH     ')
    ICOST: Optional[int] = Field(None, description='COST CALCULATION SWITCH     ')
    IFITE: Optional[int] = Field(None, description='TRANSPORT/FIGHTER/GEN AV    ')
    NOPRO: Optional[int] = Field(None, description='TAKEOFF PROFILE FOR NOISE   ')
    NPFILE: Optional[int] = Field(None, description='TAKEOFF PROFILE SWITCH      ')
    LPFILE: Optional[int] = Field(None, description='LANDING PROFILE SWITCH      ')
    NOISE: Optional[int] = Field(None, description='NOISE CALCULATIONS SWITCH   ')
    MPRINT: Optional[int] = Field(None, description='MASTER PRINT CONTROL        ')
    IXFL: Optional[int] = Field(None, description='XFLOPS DATA PLOT SWITCH     ')
    IPOLP: Optional[int] = Field(None, description='AERO POLAR PLOT SWITCH      ')
    IPLTTH: Optional[int] = Field(None, description='THRUST DATA PLOT SWITCH     ')
    IPLTHS: Optional[int] = Field(None, description='HISTORY DATA PLOT SWITCH    ')
    IPLTPS: Optional[int] = Field(None, description='EXCESS POWER PLOT SWITCH    ')


class OutputWtinNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    VMMO: Optional[float] = Field(None, description='MAX OPER MACH NUMBER      ')
    ULF: Optional[float] = Field(None, description='ULTIMATE LOAD FACTOR')
    NWREF: Optional[float] = Field(None, description='REF WEIGHT NUMBER')
    CGREFL: Optional[float] = Field(None, description='CG REFERENCE LENGTH')
    CGREFX: Optional[float] = Field(None, description='X FOR START OF CGREFL     ')
    MYWTS: Optional[int] = Field(None, description='SWITCH TO COMPUTE WEIGHTS')
    DGW: Optional[float] = Field(None, description='DESIGN GROSS WT. (RATIO)')
    HYDPR: Optional[float] = Field(None, description='HYDRAULIC SYSTEM PRESSURE')
    DIH: Optional[float] = Field(None, description='DIHEDRAL(POSITIVE)        ')
    GLOV: Optional[float] = Field(None, description='GLOVE AND BAT AREA')
    SPAN: Optional[float] = Field(None, description='SPAN                      ')
    FLAPR: Optional[float] = Field(None, description='CONTROL SURFACE AREA RATIO')
    FCOMP: Optional[float] = Field(None, description='FRACTION OF COMPOSITES')
    FAERT: Optional[float] = Field(None, description='AEROELASTIC TAILORING FACT')
    FSTRT: Optional[float] = Field(None, description='STRUT BRACING FACTOR')
    VARSWP: Optional[float] = Field(None, description='VARIABLE SWEEP FACTOR')
    SHT: Optional[float] = Field(None, description='AREA                      ')
    SWPHT: Optional[float] = Field(None, description='1/4 CHORD SWEEP ANGLE')
    ARHT: Optional[float] = Field(None, description='ASPECT RATIO')
    TRHT: Optional[float] = Field(None, description='TAPER RATIO               ')
    TCHT: Optional[float] = Field(None, description='T/C')
    HHT: Optional[float] = Field(None, description='LOCATION ON VERTICAL TAIL ')
    NVERT: Optional[int] = Field(None, description='NUMBER OF VERTICAL TAILS')
    SVT: Optional[float] = Field(None, description='AREA')
    SWPVT: Optional[float] = Field(None, description='1/4 CHORD SWEEP ANGLE')
    ARVT: Optional[float] = Field(None, description='ASPECT RATIO')
    TRVT: Optional[float] = Field(None, description='TAPER RATIO               ')
    TCVT: Optional[float] = Field(None, description='T/C')
    NFUSE: Optional[int] = Field(None, description='NUMBER OF FUSELAGES')
    XL: Optional[float] = Field(None, description='TOTAL LENGTH              ')
    WF: Optional[float] = Field(None, description='MAXIMUM WIDTH')
    DF: Optional[float] = Field(None, description='MAXIMUM DEPTH')
    CARGF: Optional[float] = Field(None, description='CARGO AIRCRAFT FACTOR     ')
    XLP: Optional[float] = Field(None, description='PASSENGER COMPART LENGTH')
    XMLG: Optional[float] = Field(None, description='LENGTH OF MAIN GEAR       ')
    XNLG: Optional[float] = Field(None, description='LENGTH OF NOSE GEAR')
    WLDG: Optional[float] = Field(None, description='DESIGN LANDING WEIGHT     ')
    MLDWT: Optional[int] = Field(None, description='SET WLDG TO END OF DESCENT')
    DLDWT: Optional[float] = Field(None, description='DELTA WEIGHT FOR MLDWT = 1')
    CARBAS: Optional[float] = Field(None, description='CARRIER BASED AIRCRAFT    ')
    NEW: Optional[int] = Field(None, description='NUMBER OF ENGINES ON WING ')
    NEF: Optional[int] = Field(None, description='NUMBER OF ENGINES ON FUSE')
    THRSO: Optional[float] = Field(None, description='BASELINE ENGINE THRUST')
    WENG: Optional[float] = Field(None, description='BASELINE ENGINE WEIGHT    ')
    EEXP: Optional[float] = Field(None, description='WEIGHT SCALING PARAMETER  ')
    WINL: Optional[float] = Field(None, description='BASELINE INLET WEIGHT')
    EINL: Optional[float] = Field(None, description='INLET WT SCALING EXPONENT')
    WNOZ: Optional[float] = Field(None, description='BASELINE NOZZLE WEIGHT')
    ENOZ: Optional[float] = Field(None, description='NOZZLE WT SCALING EXPONENT')
    XNAC: Optional[float] = Field(None, description='BASELINE NACELLE LENGTH')
    DNAC: Optional[float] = Field(None, description='BASELINE NACELLE DIAMETER ')
    WPMISC: Optional[float] = Field(None, description='ADDED MISC PROP SYSTEM WT ')
    FULDEN: Optional[float] = Field(None, description='FUEL DENSITY RATIO')
    FWMAX: Optional[float] = Field(None, description='(FUEL CAPACITY FACTOR   ')
    FULWMX: Optional[float] = Field(None, description='FUEL CAPACITY OF WING    ')
    FULFMX: Optional[float] = Field(None, description='FUEL CAPACITY OF FUSELAGE')
    FULAUX: Optional[float] = Field(None, description='AUXIL TANK FUEL CAPACITY')
    FMXTOT: Optional[float] = Field(None, description='TOTAL FUEL CAPACITY       ')
    IFUFU: Optional[int] = Field(None, description='ADJUST FUSE FUEL CAPACITY')
    NTANK: Optional[int] = Field(None, description='NUMBER OF FUEL TANKS      ')
    NPF: Optional[int] = Field(None, description='FIRST CLASS PASSENGERS')
    NPB: Optional[int] = Field(None, description='BUSINESS PASSENGERS       ')
    NPT: Optional[int] = Field(None, description='TOURIST PASSENGERS        ')
    NSTU: Optional[int] = Field(None, description='STEWARDESSES')
    NGALC: Optional[int] = Field(None, description='GALLEY CREW               ')
    NFLCR: Optional[int] = Field(None, description='FLIGHT CREW               ')
    WPPASS: Optional[float] = Field(None, description='WEIGHT PER PASSENGER')
    BPP: Optional[float] = Field(None, description='BAGGAGE PER PASSENGER     ')
    CARGOW: Optional[float] = Field(None, description='CARGO IN WING             ')
    CARGOF: Optional[float] = Field(None, description='CARGO IN FUSELAGE         ')
    PAYLMX: Optional[float] = Field(None, description='MAXIMUM PAYLOAD')
    FRWI: Optional[float] = Field(None, description='WING - TOTAL')
    FRWI1: Optional[float] = Field(None, description='WING WEIGHT FIRST TERM ')
    FRWI2: Optional[float] = Field(None, description='WING WEIGHT SECOND TERM ')
    FRWI3: Optional[float] = Field(None, description='WING WEIGHT THIRD TERM ')
    FRWI4: Optional[float] = Field(None, description='WING WEIGHT FOURTH TERM ')
    FRHT: Optional[float] = Field(None, description='HORIZONTAL TAIL           ')
    FRVT: Optional[float] = Field(None, description='VERTICAL TAIL             ')
    FRFIN: Optional[float] = Field(None, description='WING VERTICAL FIN')
    FRCAN: Optional[float] = Field(None, description='CANARD')
    FRFU: Optional[float] = Field(None, description='FUSELAGE')
    FRLGN: Optional[float] = Field(None, description='NOSE LANDING GEAR')
    FRLGM: Optional[float] = Field(None, description='MAIN LANDING GEAR')
    FRNA: Optional[float] = Field(
        None, description='NACELLES - TOTAL OR\nAIR INDUCTION SYSTEM'
    )
    WTHR: Optional[float] = Field(None, description='THRUST REVERSERS - TOTAL')
    WPMSC: Optional[float] = Field(None, description='MISC PROPULSION SYSTEMS')
    WFSYS: Optional[float] = Field(None, description='FUEL SYSTEM               ')
    FRSC: Optional[float] = Field(None, description='SURFACE CONTROLS          ')
    WAPU: Optional[float] = Field(None, description='AUXILIARY POWER UNIT')
    WIN: Optional[float] = Field(None, description='INSTRUMENT GROUP          ')
    WHYD: Optional[float] = Field(None, description='HYDRAULICS GROUP          ')
    WELEC: Optional[float] = Field(None, description='ELECTRICAL GROUP          ')
    WAVONC: Optional[float] = Field(None, description='AVIONICS GROUP            ')
    WARM: Optional[float] = Field(None, description='ARMAMENT GROUP            ')
    WFURN: Optional[float] = Field(None, description='FURNISHINGS GROUP         ')
    WAC: Optional[float] = Field(None, description='AIR CONDITIONING GROUP')
    WAI: Optional[float] = Field(
        None, description='ANTI-ICING GROUP  OR\nAUXILIARY GEAR'
    )
    WUF: Optional[float] = Field(None, description='UNUSABLE FUEL             ')
    WOIL: Optional[float] = Field(None, description='ENGINE OIL                ')
    WSRV: Optional[float] = Field(
        None, description='PASSENGER SERVICE OR AMMO \nAND NONFIXED WEAPONS'
    )
    WCON: Optional[float] = Field(
        None, description='CARGO AND BAGGAGE CONTAIN. \nOR MISCELL.USEFUL LOAD'
    )
    WAUXT: Optional[float] = Field(None, description='AUXILIARY FUEL TANKS      ')
    WFLCRB: Optional[float] = Field(None, description='FLIGHT CREW AND BAGGAGE   ')
    WSTUAB: Optional[float] = Field(None, description='CABIN CREW AND BAGGAGE    ')
    CGW: Optional[float] = Field(None, description='WING                      ')
    CGHT: Optional[float] = Field(None, description='HORIZONTAL TAIL')
    CGVT: Optional[float] = Field(None, description='VERTICAL TAIL')
    CGFIN: Optional[float] = Field(None, description='WING VERTICAL FINS        ')
    CGCAN: Optional[float] = Field(None, description='CANARD                    ')
    CGF: Optional[float] = Field(None, description='FUSELAGE                  ')
    CGLGN: Optional[float] = Field(None, description='NOSE LANDING GEAR         ')
    CGLGM: Optional[float] = Field(None, description='MAIN LANDING GEAR         ')
    CGEF: Optional[float] = Field(None, description='TWO FORWARD ENGINES       ')
    CGEA: Optional[float] = Field(None, description='ONE OR TWO AFT ENGINES    ')
    CGAP: Optional[float] = Field(None, description='AUXILIARY POWER UNIT      ')
    CGAV: Optional[float] = Field(None, description='AVIONICS GROUP')
    CGARM: Optional[float] = Field(None, description='ARMAMENT GROUP')
    CGCR: Optional[float] = Field(None, description='FLIGHT CREW')
    CGP: Optional[float] = Field(None, description='PASSENGERS                ')
    CGCW: Optional[float] = Field(None, description='CARGO/EXT STORES IN WING  ')
    CGCF: Optional[float] = Field(None, description='CARGO/EXT STORES IN FUSE  ')
    CGZWF: Optional[float] = Field(None, description='FUSELAGE FUEL')
    CGFWF: Optional[float] = Field(None, description='WING FUEL')
    CGN: Optional[float] = Field(None, description='AIR INDUCTION SYSTEM      ')
    CGAC: Optional[float] = Field(None, description='AIR CONDITIONING')
    CGAI: Optional[float] = Field(None, description='AUXILIARY GEAR')
    CGAUT: Optional[float] = Field(None, description='AUXILIARY TANKS')
    CGAMMO: Optional[float] = Field(None, description='AMMO AND NONFIXED GUNS')
    CGMIS: Optional[float] = Field(None, description='MISCELLANEOUS USEFUL LOAD ')
    CGPOW: Optional[float] = Field(None, description='SYSTEM WT FOR ALT ENGINES ')
    CGALTE: Optional[float] = Field(None, description='ALTERNATE ENGINES')
    CGBAT: Optional[float] = Field(None, description='ALTERNATE ENERGY STORAGE  ')


class DesignVariableData(BaseModel):
    class Config:
        extra = Extra.forbid

    VALUE: Optional[float] = Field(None, description='VALUE')
    ACTIVITY: Optional[float] = Field(None, description='ACTIVITY')
    LOWER_BOUND: Optional[float] = Field(None, description='LOWER_BOUND')
    UPPER_BOUND: Optional[float] = Field(None, description='UPPER_BOUND')
    SCALE_FACTOR: Optional[float] = Field(None, description='SCALE_FACTOR')


class OutputAerinNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    MYAERO: Optional[int] = Field(None, description='AERODYNAMIC INPUT METHOD')
    IWAVE: Optional[int] = Field(None, description='# [None]')
    FWAVE: Optional[float] = Field(None, description='WAVE DRAG FACTOR')
    ITPAER: Optional[int] = Field(None, description='LINEAR/PARABOLIC INTERP')
    IBO: Optional[int] = Field(None, description='AERO MATRIX FORMAT SWITCH')
    CAM: Optional[float] = Field(
        None, description='MAX CAMBER AT 70 PERCENT SEMISPAN [PERCENT CHORD]'
    )
    SBASE: Optional[float] = Field(None, description='AIRCRAFT BASE AREA [SQ FT]')
    AITEK: Optional[float] = Field(None, description='WING TECHNOLOGY')
    MODARO: Optional[int] = Field(None, description='MODIFY EDET DATA')
    FCLDES: Optional[float] = Field(None, description='FIXED DESIGN CL')
    FMDES: Optional[float] = Field(None, description='FIXED DESIGN MACH NUMBER')
    XLLAM: Optional[float] = Field(None, description='TURBULENT/LAMINAR FLOW')
    E: Optional[float] = Field(None, description='AERO EFFICIENCY FACTOR')
    SWETW: Optional[float] = Field(None, description='WING WETTED AREA')
    SWETH: Optional[float] = Field(None, description='HOR. TAIL WETTED AREA')
    SWETV: Optional[float] = Field(None, description='VERT. TAIL WETTED AREA')
    SWETF: Optional[float] = Field(None, description='FUSELAGE WETTED AREA')
    SWETN: Optional[float] = Field(None, description='NACELLE WETTED AREA')
    SWETC: Optional[float] = Field(None, description='CANARD WETTED AREA')
    WRATIO: Optional[float] = Field(
        None, description='RATIO OF MAX. LANDING WT. TO MAX. TAKEOFF WT.'
    )
    VAPPR: Optional[float] = Field(None, description='MAX. LANDING VELOCITY [KTS]')
    FLTO: Optional[float] = Field(None, description='MAX. TAKEOFF FIELD LENGTH [FT]')
    FLLDG: Optional[float] = Field(None, description='MAX. LANDING FIELD LENGTH [FT]')
    CLTOM: Optional[float] = Field(None, description='MAX. CL TAKEOFF CONFIG.')
    CLLDM: Optional[float] = Field(None, description='MAX. CL LANDING CONFIG.')
    CLAPP: Optional[float] = Field(None, description='APPROACH CL')
    DRATIO: Optional[float] = Field(None, description='AIR DENSITY RATIO')
    ELODSS: Optional[float] = Field(None, description='L/D RATIO 2ND SEG. CLIMB')
    ELODMA: Optional[float] = Field(None, description='L/D RATIO MISSED APPROACH')
    THROFF: Optional[float] = Field(None, description='THRUST PER ENGINE TAKEOFF')
    THRSS: Optional[float] = Field(
        None, description='THRUST PER ENGINE 2ND SEG. CLIMB [LBF]'
    )
    THRMA: Optional[float] = Field(
        None, description='THRUST PER ENGINE MISSED APPROACH [LBF]'
    )


class OutputEngdinNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    NGPRT: Optional[int] = Field(None, description='ENGINE DECK PRINT CONTROL')
    IGENEN: Optional[int] = Field(None, description='ENGINE DECK SOURCE SWITCH')
    EXTFAC: Optional[float] = Field(
        None, description='SLOPE FACTOR FOR EXTRAPOLATING FUEL FLOWS'
    )
    FFFSUB: Optional[float] = Field(None, description='SUBSONIC FUEL FLOW FACTOR')
    FFFSUP: Optional[float] = Field(None, description='SUPERSONIC FUEL FLOW FACT')
    IDLE: Optional[int] = Field(None, description='FLIGHT IDLE SWITCH')
    NONEG: Optional[int] = Field(None, description='IGNORE NEGATIVE THRUSTS')
    FIDMIN: Optional[float] = Field(None, description='MIN IDLE FUEL FLOW FRACT')
    FIDMAX: Optional[float] = Field(None, description='MAX IDLE FUEL FLOW FRACT')
    IXTRAP: Optional[int] = Field(None, description='SFC EXTRAPOLATION SWITCH')
    IFILL: Optional[int] = Field(None, description='PART POWER DATA SWITCH')
    MAXCR: Optional[int] = Field(None, description='MAX. CRUISE POWER SETTING')
    BOOST: Optional[float] = Field(None, description='BOOST ENGINE SWITCH')
    DFFAC: Optional[float] = Field(None, description='FUEL FLOW SCALING CONSTANT TERM')
    FFFAC: Optional[float] = Field(None, description='FUEL FLOW SCALING LINEAR TERM')
    NOX: Optional[int] = Field(None, description='NITROGEN OXIDES SWITCH')
    INSDRG: Optional[int] = Field(None, description='INSTALLATION DRAG SWITCH')
    EIFILE: Optional[str] = Field(None, description='ENGINE DECK 1 FILE NAME')


class PointEngineDeckSummary(BaseModel):
    class Config:
        extra = Extra.forbid

    MACH: Optional[float] = Field(None, description='MACH')
    ALTITUDE: Optional[float] = Field(None, description='ALTITUDE')
    THRUSTS: Optional[List[float]] = Field(None, description='THRUSTS')
    FUEL_FLOWS: Optional[List[float]] = Field(None, description='FUEL FLOWS')
    SFCS: Optional[List[float]] = Field(None, description='SFCS')
    NOX_RATIOS: Optional[List[float]] = Field(None, description='NOX_RATIOS_FOLLOW')


class OutputMissinNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    INDR: Optional[int] = Field(None, description='ENDURANCE MISSION SWITCH')
    FACT: Optional[float] = Field(None, description='OVERALL FUEL FLOW FACTOR')
    FCDO: Optional[float] = Field(None, description='CDO FACTOR')
    FCDI: Optional[float] = Field(None, description='CDI FACTOR')
    FCDSUB: Optional[float] = Field(None, description='SUBSONIC CD FACTOR')
    FCDSUP: Optional[float] = Field(None, description='SUPERSONIC CD FACTOR')
    ISKAL: Optional[int] = Field(None, description='ENGINE SCALING SWITCH')
    OWFACT: Optional[float] = Field(None, description='OWE FACTOR')
    IFLAG: Optional[int] = Field(None, description='PRINT FLAG')
    MSUMPT: Optional[int] = Field(None, description='DETAILED MISSION PRINT')
    DTC: Optional[float] = Field(None, description='TEMPERATURE DEVIATION [DEG C]')
    IRW: Optional[int] = Field(None, description='CALC RAMP WT OR RANGE')
    RTOL: Optional[float] = Field(None, description='RANGE TOLERANCE [N MI]')
    IATA: Optional[int] = Field(None, description='ATA TRAFFIC ALLOWANCE')
    TLWIND: Optional[float] = Field(None, description='TAIL WIND VELOCITY [KTS]')
    DWT: Optional[float] = Field(None, description='WEIGHT INCREMENT [LBF]')
    TAKOTM: Optional[float] = Field(None, description='TAKEOFF TIME [MIN]')
    TAXOTM: Optional[float] = Field(None, description='TAXI-OUT TIME [MIN]')
    APPRTM: Optional[float] = Field(None, description='APPROACH TIME [MIN]')
    APPFFF: Optional[float] = Field(None, description='APPROACH FUEL FLOW FACTOR')
    TAXITM: Optional[float] = Field(None, description='TAXI-IN TIME [MIN]')
    ITTFF: Optional[int] = Field(None, description='TAKEOFF POWER SETTING')
    CLMMIN: Optional[float] = Field(None, description='MINIMUM CLIMB MACH NUMBER')
    CLMMAX: Optional[float] = Field(None, description='MAXIMUM CLIMB MACH NUMBER')
    CLAMIN: Optional[float] = Field(None, description='MINIMUM CLIMB ALTITUDE, FT')
    CLAMAX: Optional[float] = Field(None, description='MAXIMUM CLIMB ALTITUDE, FT')
    NINCL: Optional[int] = Field(None, description='NUMBER OF CLIMB STEPS')
    FWF: Optional[float] = Field(None, description='CLIMB OPTIMIZATION FACTOR')
    NCRCL: Optional[int] = Field(None, description='FOLLOWING CRUISE SEGMENT')
    CLDCD: Optional[float] = Field(None, description='DRAG COEFFICIENT INCREMENT')
    IPPCL: Optional[int] = Field(None, description='NO. OF POWER SETTINGS')
    ISTCL: Optional[int] = Field(None, description='STORE DRAG DURING CLIMB')
    MAXCL: Optional[int] = Field(None, description='MAX CLIMB POWER SETTING')
    IFAACL: Optional[int] = Field(None, description='FAA CLIMB ENFORCED')
    IFAADE: Optional[int] = Field(None, description='FAA DESCENT ENFORCED')
    NODIVE: Optional[int] = Field(None, description='MINIMUM CLIMB RATE SWITCH')
    DIVLIM: Optional[float] = Field(None, description='MINIMUM CLIMB RATE [FT/MIN]')
    QLIM: Optional[float] = Field(None, description='Q LIMIT IN CLIMB [PSF]')
    RDLIM: Optional[float] = Field(None, description='MAXIMUM RATE OF DESCENT [FT/MIN]')
    IOC: Optional[int] = Field(None, description='CRUISE OPTION SWITCH')
    FFUEL: Optional[float] = Field(None, description='CRUISE OPT FUEL FACTOR')
    FNOX: Optional[float] = Field(None, description='CRUISE OPT NOX FACTOR')
    CRMACH: Optional[float] = Field(None, description='MAXIMUM MACH NUMBER')
    CRALT: Optional[float] = Field(None, description='MAXIMUM ALTITUDE, FT')
    CRDCD: Optional[float] = Field(None, description='DRAG COEFFICIENT INCREMENT')
    ISTCR: Optional[int] = Field(None, description='STORE DRAG DURING CRUISE')
    FLRCR: Optional[float] = Field(None, description='LONG RANGE CRUISE FACTOR')
    CRMMIN: Optional[float] = Field(None, description='MINIMUM MACH NUMBER')
    CRCLMX: Optional[float] = Field(None, description='MAXIMUM LIFT COEFFICIENT')
    IFEATH: Optional[int] = Field(None, description='ENGINE FEATHERING ALLOWED')
    FEATHF: Optional[float] = Field(None, description='ENGINE FRACTION REMAINING')
    CDFETH: Optional[float] = Field(None, description='CD INCREASE FOR FEATHERING')
    HPMIN: Optional[float] = Field(None, description='MIN CRUISE ALTITUDE, FT')
    DCWT: Optional[float] = Field(None, description='INCREMENT IN CRUISE WT. [LBF]')
    RCIN: Optional[float] = Field(None, description='RATE OF CLIMB CEILING [FT/MIN]')
    IVS: Optional[int] = Field(None, description='DESCENT OPTION SWITCH')
    DECL: Optional[float] = Field(None, description='DESCENT LIFT COEFF.')
    DEMMIN: Optional[float] = Field(None, description='MINIMUM DESCENT MACH NO.')
    DEMMAX: Optional[float] = Field(None, description='MAXIMUM DESCENT MACH NO.')
    DEAMIN: Optional[float] = Field(None, description='MINIMUM DESCENT ALTITUDE [FT]')
    DEAMAX: Optional[float] = Field(None, description='MAXIMUM DESCENT ALTITUDE [FT]')
    NINDE: Optional[int] = Field(None, description='NUMBER OF DESCENT STEPS')
    DEDCD: Optional[float] = Field(None, description='DRAG COEFFICIENT INCREMENT')
    ISTDE: Optional[int] = Field(None, description='STORE DRAG DURING DESCENT')
    IRS: Optional[int] = Field(None, description='RESERVE CALC. OR CONST')
    RESRFU: Optional[float] = Field(None, description='RESERVE FUEL [LBM]')
    RESTRP: Optional[float] = Field(None, description='FRACTION OF TRIP FUEL')
    RESRPW: Optional[float] = Field(None, description='RESERVE ALTERNATE ENERGY')
    RPWTRP: Optional[float] = Field(None, description='FRACTION OF TRIP ENERGY')
    TIMMAP: Optional[float] = Field(None, description='MISSED APPROACH TIME [MIN]')
    ALTRAN: Optional[float] = Field(
        None, description='RANGE TO ALTERNATE AIRPORT [N MI]'
    )
    NCLRES: Optional[int] = Field(None, description='RESERVE CLIMB SCHEDULE')
    NCRRES: Optional[int] = Field(None, description='RESERVE CRUISE SCHEDULE')
    SREMCH: Optional[float] = Field(None, description='START RESERVE MACH NUMBER')
    EREMCH: Optional[float] = Field(None, description='END RESERVE MACH NUMBER')
    SREALT: Optional[float] = Field(None, description='START RESERVE ALTITUDE [FT]')
    EREALT: Optional[float] = Field(None, description='END RESERVE ALTITUDE [FT]')
    HOLDTM: Optional[float] = Field(None, description='RESERVE HOLDING TIME [MIN]')
    NCRHOL: Optional[int] = Field(None, description='HOLD CRUISE SCHEDULE')
    IHOPOS: Optional[int] = Field(None, description='HOLD POSITION SWITCH')
    ICRON: Optional[int] = Field(None, description='CRUISE ONLY SWITCH')
    THOLD: Optional[float] = Field(None, description='2ND RES HOLD TIME OR FRAC [MIN]')
    NCRTH: Optional[int] = Field(None, description='THOLD CRUISE SCHEDULE')


class OutputTolinNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    APA: Optional[float] = Field(None, description='AIRPORT ALTITUDE [FT]')
    DTCT: Optional[float] = Field(None, description='DELTA TEMPERATURE [DEG C]')
    SWREF: Optional[float] = Field(None, description='REFERENCE WING AREA [SQ FT]')
    ARRET: Optional[float] = Field(None, description='REFERENCE ASPECT RATIO')
    WHGT: Optional[float] = Field(None, description='WING HEIGHT ABOVE GROUND [FT]')
    ALPRUN: Optional[float] = Field(None, description='ANGLE OF ATTACK ON GROUND [DEG]')
    TINC: Optional[float] = Field(None, description='THRUST INCIDENCE ON GRND [DEG]')
    ROLLMU: Optional[float] = Field(None, description='COEF. OF ROLLING FRICTION')
    BRAKMU: Optional[float] = Field(None, description='COEF. OF FRICTION W/BRAKES')
    CDGEAR: Optional[float] = Field(None, description='LANDING GEAR DRAG COEF.')
    CDEOUT: Optional[float] = Field(None, description='ENGINE OUT DELTA CD')
    CLSPOL: Optional[float] = Field(None, description='SPOILER LIFT COEFFICIENT')
    CDSPOL: Optional[float] = Field(None, description='SPOILER DRAG COEFFICIENT')
    INCGEF: Optional[int] = Field(None, description='GROUND EFFECTS SWITCH')
    ARGEF: Optional[float] = Field(None, description='AR FACTOR FOR GRND EFF.')
    ITIME: Optional[int] = Field(None, description='PROFILE PRINT SWITCH')
    CLTOM: Optional[float] = Field(None, description='MAXIMUM LIFT COEFFICIENT')
    CDMTO: Optional[float] = Field(None, description='MINIMUM DRAG COEFFICIENT')
    FCDMTO: Optional[float] = Field(None, description='WING FRACTION OF CDMTO')
    ALMXTO: Optional[float] = Field(None, description='MAXIMUM ANGLE OF ATTACK [DEG]')
    OBSTO: Optional[float] = Field(None, description='OBSTACLE HEIGHT [FT]')
    ALPROT: Optional[float] = Field(None, description='MAX ALPHA DURING ROTATION [DEG]')
    VROTAT: Optional[float] = Field(
        None, description='ROTATION VELOCITY [KTS OR % VSTALL]'
    )
    VANGL: Optional[float] = Field(None, description='ROTATION RATE [DEG/SEC]')
    THFACT: Optional[float] = Field(None, description='THRUST MULTIPLIER')
    FTOCL: Optional[float] = Field(None, description='TAKEOFF LIFT FACTOR')
    FTOCD: Optional[float] = Field(None, description='TAKEOFF DRAG FACTOR')
    IGOBS: Optional[int] = Field(None, description='GEAR RETRACT AT OBSTACLE ?')
    TDELG: Optional[float] = Field(None, description='TIME DELAY AFTER L.O./OBS [SEC]')
    TIGEAR: Optional[float] = Field(None, description='TIME REQ. TO RETRACT GEAR [SEC]')
    PILOTT: Optional[float] = Field(None, description='PILOT REACTION TIME [SEC]')
    DELVTO: Optional[float] = Field(
        None, description='GROUND RUN VELOCITY STEP [FT/SEC]'
    )
    DELTRO: Optional[float] = Field(None, description='ROTATION TIME STEP [SEC]')
    DELTCL: Optional[float] = Field(None, description='CLIMBOUT TIME STEP [SEC]')
    IBAL: Optional[int] = Field(None, description='BALANCED FIELD LENGTH ?')
    ISPOL: Optional[int] = Field(None, description='SPOILERS DURING ABORT ?')
    IREV: Optional[int] = Field(None, description='ABORT THRUST REV. OPTION')
    INTHTO: Optional[int] = Field(None, description='THRUST INPUT OPTION')
    ITXOUT: Optional[int] = Field(None, description='TAXI OUT FUEL SWITCH')
    ALPTO: Optional[List[float]] = Field(None, description='ANGLE OF ATTACK')
    CLTO: Optional[List[float]] = Field(None, description='LIFT COEFFICIENT')
    CDTO: Optional[List[float]] = Field(None, description='DRAG COEFFICIENT')
    VELTO: Optional[List[float]] = Field(None, description='VELOCITY, FT/SEC')
    THRTO: Optional[List[float]] = Field(None, description='THRUST, LB')
    CLLDM: Optional[float] = Field(None, description='MAXIMUM LIFT COEFFICIENT')
    CDMLD: Optional[float] = Field(None, description='MINIMUM DRAG COEFFICIENT')
    FCDMLD: Optional[float] = Field(None, description='WING FRACTION OF CDMLD  ')
    ALMXLD: Optional[float] = Field(None, description='MAXIMUM ANGLE OF ATTACK [DEG]')
    OBSLD: Optional[float] = Field(None, description='OBSTACLE HEIGHT [FT]')
    APRHGT: Optional[float] = Field(None, description='START APPROACH HEIGHT [FT]')
    APRANG: Optional[float] = Field(
        None, description='APPROACH FLIGHT PATH ANGLE [DEG]'
    )
    DVAPP: Optional[float] = Field(None, description='DELTA APPROACH VELOCITY [KTS]')
    FLDCL: Optional[float] = Field(None, description='LANDING LIFT FACTOR     ')
    FLDCD: Optional[float] = Field(None, description='LANDING DRAG FACTOR     ')
    TDSINK: Optional[float] = Field(
        None, description='SINK RATE AT TOUCH DOWN [FT/SEC]'
    )
    VANGLD: Optional[float] = Field(None, description='FLARE RATE [DEG/SEC]')
    NOFLAR: Optional[int] = Field(None, description='NO FLARE ON LANDING ?   ')
    TISPOL: Optional[float] = Field(None, description='TIME TO SPOILER ACTUATION [SEC]')
    TICUT: Optional[float] = Field(None, description='TIME TO ENGINE CUTBACK [SEC]')
    TIBRAK: Optional[float] = Field(None, description='TIME TO BRAKE APPLICATION [SEC]')
    ACCLIM: Optional[float] = Field(None, description='DECELERATION LIMIT [FT/SEC2]')
    MAGRUP: Optional[int] = Field(None, description='MISSED APPROACH GEAR UP ')
    DELHAP: Optional[float] = Field(None, description='APPROACH ALTITUDE STEP [FT]')
    DELDFL: Optional[float] = Field(None, description='FLARE DISTANCE STEP [FT]')
    DELTRN: Optional[float] = Field(None, description='RUNOUT TIME STEP [SEC]')
    INTHLD: Optional[int] = Field(None, description='THRUST INPUT OPTION     ')
    ALPLD: Optional[List[float]] = Field(None, description='ANGLE OF ATTACK')
    CLLD: Optional[List[float]] = Field(None, description='LIFT COEFFICIENT')
    CDLD: Optional[List[float]] = Field(None, description='DRAG COEFFICIENT')
    VELLD: Optional[List[float]] = Field(None, description='VELOCITY, FT/SEC')
    THRLD: Optional[List[float]] = Field(None, description='THRUST, LB')


class ComponentDragData(BaseModel):
    class Config:
        extra = Extra.forbid

    COMPONENT: Optional[str] = Field(None, description='COMPONENT')
    SWET: Optional[float] = Field(None, description='SWET')
    LENGTH: Optional[float] = Field(None, description='LENGTH')
    FINENESS: Optional[float] = Field(None, description='FINENESS')
    FORM: Optional[float] = Field(None, description='FORM')
    RN: Optional[float] = Field(None, description='RN')
    CF: Optional[float] = Field(None, description='CF')
    CDF: Optional[float] = Field(None, description='CDF')


class ChangeDragCoefficient(BaseModel):
    class Config:
        extra = Extra.forbid

    ALTITUDE: Optional[List[float]] = Field(None, description='ALTITUDE')
    MACH: Optional[List[float]] = Field(None, description='MACH')
    VALUES: Optional[List[List[float]]] = Field(None, description='VALUES')


class DragPolar(BaseModel):
    class Config:
        extra = Extra.forbid

    ALTITUDE: Optional[float] = Field(None, description='ALTITUDE [FT]')
    MACH: Optional[List[float]] = Field(None, description='MACH')
    CL: Optional[List[float]] = Field(None, description='CL')
    VALUES: Optional[List[List[float]]] = Field(None, description='VALUES')


class PressureDrag(BaseModel):
    class Config:
        extra = Extra.forbid

    MACH: Optional[List[float]] = Field(None, description='MACH')
    CL: Optional[List[float]] = Field(None, description='CL')
    VALUES: Optional[List[List[float]]] = Field(None, description='VALUES')


class CruiseSummaryData(BaseModel):
    class Config:
        extra = Extra.forbid

    WEIGHT: Optional[List[float]] = Field(None, description='WEIGHT')
    ALTITUDE: Optional[List[float]] = Field(None, description='ALTITUDE')
    THRUST_AVAILABLE: Optional[List[float]] = Field(
        None, description='THRUST_AVAILABLE'
    )
    THRUST_REQUIRED: Optional[List[float]] = Field(None, description='THRUST_REQUIRED')
    FUEL_FLOW: Optional[List[float]] = Field(None, description='FUEL_FLOW')
    SFC: Optional[List[float]] = Field(None, description='SFC')
    MACH_NUMBER: Optional[List[float]] = Field(None, description='MACH_NUMBER')
    VELOCITY: Optional[List[float]] = Field(None, description='VELOCITY')
    SPECIFIC_RANGE: Optional[List[float]] = Field(None, description='SPECIFIC_RANGE')
    RATE_OF_CLIMB: Optional[List[float]] = Field(None, description='RATE_OF_CLIMB')
    CL: Optional[List[float]] = Field(None, description='CL')
    L_D: Optional[List[float]] = Field(None, description='L_D')
    ENGINES_OPERATING: Optional[List[float]] = Field(
        None, description='ENGINES_OPERATING'
    )
    NOX_RATE: Optional[List[float]] = Field(None, description='NOX_RATE')


class RangeTimeSummaryData(BaseModel):
    class Config:
        extra = Extra.forbid

    WEIGHT: Optional[List[float]] = Field(None, description='WEIGHT [LB]')
    RANGE: Optional[List[float]] = Field(None, description='RANGE [NM]')
    TIME: Optional[List[float]] = Field(None, description='TIME [HR]')


class MassAndBalanceSummaryComponent(BaseModel):
    class Config:
        extra = Extra.forbid

    NAME: Optional[str] = Field(None, description='MASS_AND_BALANCE_SUMMARY')
    PERCENT_WREF: Optional[float] = Field(None, description='PERCENT_WREF')
    POUNDS: Optional[float] = Field(None, description='POUNDS')
    PERCENT_LREF: Optional[float] = Field(None, description='PERCENT_LREF')
    HORI_CG: Optional[float] = Field(None, description='HORI_CG [IN]')


class NonCruiseProfileData(BaseModel):
    class Config:
        extra = Extra.forbid

    SEGMENT: Optional[str] = Field(None, description='SEGMENT')
    WEIGHT: Optional[List[float]] = Field(None, description='WEIGHT')
    ENERGY: Optional[List[float]] = Field(None, description='ENERGY')
    ALT: Optional[List[float]] = Field(None, description='ALT')
    MACH: Optional[List[float]] = Field(None, description='MACH')
    VEL: Optional[List[float]] = Field(None, description='VEL')
    RCI: Optional[List[float]] = Field(None, description='RCI')
    PC: Optional[List[float]] = Field(None, description='PC')
    INCREMENTAL_TIME: Optional[List[float]] = Field(
        None, description='INCREMENTAL_TIME'
    )
    INCREMENTAL_DIST: Optional[List[float]] = Field(
        None, description='INCREMENTAL_DIST'
    )
    INREMENTAL_FUEL: Optional[List[float]] = Field(None, description='INREMENTAL_FUEL')
    Q: Optional[List[float]] = Field(None, description='Q')
    CUMULATIVE_TIME: Optional[List[float]] = Field(None, description='CUMULATIVE_TIME')
    CUMULATIVE_DIST: Optional[List[float]] = Field(None, description='CUMULATIVE_DIST')
    CUMULATIVE_FUEL: Optional[List[float]] = Field(None, description='FUEL')
    CL: Optional[List[float]] = Field(None, description='CL')
    L_D: Optional[List[float]] = Field(None, description='L/D')
    THRUST: Optional[List[float]] = Field(None, description='THRUST')
    THRUST_TMAX: Optional[List[float]] = Field(None, description='/TMAX')


class ConfigurationDataAfterResizing(BaseModel):
    class Config:
        extra = Extra.forbid

    OPERATING_WEIGHT_EMPTY: Optional[float] = Field(
        None, description='OPERATING WEIGHT EMPTY [LB]'
    )
    PAYLOAD: Optional[float] = Field(None, description='PAYLOAD [LB]')
    MAXIMUM_FUEL: Optional[float] = Field(None, description='MAXIMUM FUEL [LB]')
    GROSS_WEIGHT: Optional[float] = Field(None, description='GROSS WEIGHT [LB]')
    REFERENCE_WING_AREA: Optional[float] = Field(
        None, description='REFERENCE WING AREA [SQ FT]'
    )
    WING_LOADING: Optional[float] = Field(None, description='WING LOADING [LB / SQ FT]')
    THRUST_PER_ENGINE: Optional[float] = Field(
        None, description='THRUST PER ENGINE [LB]'
    )
    ENGINE_SCALE_FACTOR: Optional[float] = Field(
        None, description='ENGINE SCALE FACTOR [None]'
    )
    THRUST_WEIGHT_RATIO: Optional[float] = Field(
        None, description='THRUST-WEIGHT RATIO [None]'
    )


class MissionSummarySegment(BaseModel):
    class Config:
        extra = Extra.forbid

    SEGMENT: Optional[str] = Field(None, description='SEGMENT')
    INITIAL_WT: Optional[float] = Field(None, description='INITIAL_WT')
    FUEL_SEGMT: Optional[float] = Field(None, description='FUEL_SEGMT')
    FUEL_TOTAL: Optional[float] = Field(None, description='FUEL_TOTAL')
    TIME_SEGMT: Optional[float] = Field(None, description='TIME_SEGMT')
    TIME_TOTAL: Optional[float] = Field(None, description='TIME_TOTAL')
    DIST_SEGMT: Optional[float] = Field(None, description='DIST_SEGMT')
    DIST_TOTAL: Optional[float] = Field(None, description='DIST_TOTAL')
    MACH_NUMBER_START: Optional[float] = Field(None, description='MACH_NUMBER_START')
    MACH_NUMBER_END: Optional[float] = Field(None, description='MACH_NUMBER_END')
    ALTITUDE_START: Optional[float] = Field(None, description='ALTITUDE_START')
    ALTITUDE_END: Optional[float] = Field(None, description='ALTITUDE_END')
    ALTERNATE_FUEL_SEGMT: Optional[float] = Field(
        None, description='ALTERNATE_FUEL_SEGMT'
    )
    ALTERNATE_FUEL_TOTAL: Optional[float] = Field(
        None, description='ALTERNATE_FUEL_TOTAL'
    )
    NOX_EMISS_SEGMT: Optional[float] = Field(None, description='NOX_EMISS_SEGMT')
    NOX_EMISS_TOTAL: Optional[float] = Field(None, description='NOX_EMISS_TOTAL')


class SegmentData(BaseModel):
    class Config:
        extra = Extra.forbid

    SEGMENT: Optional[str] = Field(None, description='SEGMENT')
    WEIGHT: Optional[List[float]] = Field(None, description='WEIGHT')
    ALTITUDE: Optional[List[float]] = Field(None, description='ALTITUDE')
    MACH: Optional[List[float]] = Field(None, description='MACH_NO.')
    DELTA_T: Optional[List[float]] = Field(None, description='DELTA_T')
    DELTA_D: Optional[List[float]] = Field(None, description='DELTA_D')
    DELTA_F: Optional[List[float]] = Field(None, description='DELTA_F')
    THRUST: Optional[List[float]] = Field(None, description='THRUST')
    FUEL_FLOW: Optional[List[float]] = Field(None, description='FUEL_FLOW')
    EX_POW: Optional[List[float]] = Field(None, description='EX_POW')
    CLIFT: Optional[List[float]] = Field(None, description='CLIFT')
    LIFT: Optional[List[float]] = Field(None, description='LIFT')
    L_D: Optional[List[float]] = Field(None, description='L/D')
    Q: Optional[List[float]] = Field(None, description='Q')
    PCODE: Optional[List[int]] = Field(None, description='PCODE')
    ENERGY: Optional[List[float]] = Field(None, description='ENERGY')
    VELOCITY: Optional[List[float]] = Field(None, description='VELOCITY')
    TIME: Optional[List[float]] = Field(None, description='TIME')
    DIST: Optional[List[float]] = Field(None, description='DIST')
    FUEL: Optional[List[float]] = Field(None, description='FUEL')
    T_TMAX: Optional[List[float]] = Field(None, description='T/TMAX')
    SFC: Optional[List[float]] = Field(None, description='SFC')
    DH_DT_STAR: Optional[List[float]] = Field(None, description='DH/DT*')
    CDRAG: Optional[List[float]] = Field(None, description='CDRAG')
    DRAG: Optional[List[float]] = Field(None, description='DRAG')
    SP_RANGE: Optional[List[float]] = Field(None, description='SP_RANGE')
    NOX: Optional[List[float]] = Field(None, description='NOX')
    ENG_PAR: Optional[List[float]] = Field(None, description='ENG_PAR')


class LandingPoint(BaseModel):
    class Config:
        extra = Extra.forbid

    NAME: Optional[str] = Field(None, description='NAME')
    VELOCITY: Optional[float] = Field(None, description='VELOCITY')
    TIME: Optional[float] = Field(None, description='TIME')
    DISTANCE: Optional[float] = Field(None, description='DISTANCE')
    ALPHA: Optional[float] = Field(None, description='ALPHA')
    ALTITUDE: Optional[float] = Field(None, description='ALTITUDE')


class AbortedTakeoffPoint(BaseModel):
    class Config:
        extra = Extra.forbid

    NAME: Optional[str] = Field(None, description='ACCELERATE_-_STOP_DISTANCE')
    VELOCITY: Optional[float] = Field(None, description='VELOCITY')
    TIME: Optional[float] = Field(None, description='TIME')
    DISTANCE: Optional[float] = Field(None, description='DISTANCE')


class TakeoffData(BaseModel):
    class Config:
        extra = Extra.forbid

    TIME: Optional[List[float]] = Field(None, description='TIME')
    DISTANCE: Optional[List[float]] = Field(None, description='DISTANCE')
    ALTITUDE: Optional[List[float]] = Field(None, description='ALTITUDE')
    VELOCITY: Optional[List[float]] = Field(None, description='VELOCITY')
    MACH: Optional[List[float]] = Field(None, description='MACH')
    CLIMB_ANGLE: Optional[List[float]] = Field(None, description='CLIMB ANGLE')
    ATTACK_ANGLE: Optional[List[float]] = Field(None, description='ATTACK ANGLE')
    ENGINE_INCIDENCE: Optional[List[float]] = Field(
        None, description='ENGINE INCIDENCE'
    )
    ENGINE_THRUST: Optional[List[float]] = Field(None, description='ENGINE THRUST')
    LIFT_COEFFICIENT: Optional[List[float]] = Field(
        None, description='LIFT COEFFICIENT'
    )
    DRAG_COEFFICIENT: Optional[List[float]] = Field(
        None, description='DRAG COEFFICIENT'
    )
    L_D: Optional[List[float]] = Field(None, description='L/D')
    ACCELERATION: Optional[List[float]] = Field(None, description='ACCELERATION')


class TakeoffPoint(BaseModel):
    class Config:
        extra = Extra.forbid

    NAME: Optional[str] = Field(None, description='NAME')
    VELOCITY: Optional[float] = Field(None, description='VELOCITY')
    TIME: Optional[float] = Field(None, description='TIME')
    DISTANCE: Optional[float] = Field(None, description='DISTANCE')
    ALPHA: Optional[float] = Field(None, description='ALPHA')
    GAMMA: Optional[float] = Field(None, description='GAMMA')


class AllEnginesOperativeTakeoffData(TakeoffData):
    POINTS: Optional[List[TakeoffPoint]] = Field(None, description='ENGINE')
    FAR_TAKEOFF_FIELD_LENGTH: Optional[float] = Field(
        None, description='FAR TAKEOFF FIELD LENGTH'
    )


class ObjVarConstrSummary(BaseModel):
    class Config:
        extra = Extra.forbid

    FUEL: Optional[float] = Field(None, description='FUEL')
    RANGE: Optional[float] = Field(None, description='RANGE')
    VAPP: Optional[float] = Field(None, description='VAPP')
    FAROFF: Optional[float] = Field(None, description='FAROFF')
    FARLDG: Optional[float] = Field(None, description='FARLDG')
    AMFOR: Optional[float] = Field(None, description='AMFOR')
    SSFOR: Optional[float] = Field(None, description='SSFOR')
    GW: Optional[float] = Field(None, description='GW')
    AR: Optional[float] = Field(None, description='AR')
    THRUST: Optional[float] = Field(None, description='THRUST')
    SW: Optional[float] = Field(None, description='SW')
    TR: Optional[float] = Field(None, description='TR')
    SWEEP: Optional[float] = Field(None, description='SWEEP')
    TCA: Optional[float] = Field(None, description='TCA')
    VCMN: Optional[float] = Field(None, description='VCMN')
    CH: Optional[float] = Field(None, description='CH')
    W_S: Optional[float] = Field(None, description='W/S')
    T_W: Optional[float] = Field(None, description='T/W')
    F0: Optional[float] = Field(None, description='T/W')
    OBJ: Optional[float] = Field(None, description='T/W')
    PEN: Optional[float] = Field(None, description='T/W')
    G: Optional[List[float]] = Field(None, description='T/W')


class OutputConfinNamelist(BaseModel):
    class Config:
        extra = Extra.forbid

    DESRNG: Optional[float] = Field(None, description='DESIGN RANGE [N MI]')
    WSR: Optional[float] = Field(None, description='WING LOADING REQUIRED')
    TWR: Optional[float] = Field(None, description='THRUST/WEIGHT REQUIRED')
    PGLOV: Optional[float] = Field(None, description='GLOVE/WING AREA REQUIRED')
    HTVC: Optional[float] = Field(None, description='HORIZ TAIL VOLUME COEF')
    VTVC: Optional[float] = Field(None, description='VERT TAIL VOLUME COEF')
    ICOST: Optional[int] = Field(None, description='COST CALCULATION SWITCH')
    FUNCTION: Optional[str] = Field(None, description='FUNCTION TO BE OPTIMIZED - OBJ')
    GW: Optional[DesignVariableData] = Field(None, description='RAMP WEIGHT, LBF')
    AR: Optional[DesignVariableData] = Field(None, description='WING ASPECT RATIO')
    THRUST: Optional[DesignVariableData] = Field(
        None, description='THRUST PER ENGINE, LBF'
    )
    SW: Optional[DesignVariableData] = Field(None, description='REF WING AREA, SQ FT')
    TR: Optional[DesignVariableData] = Field(None, description='WING TAPER RATIO')
    SWEEP: Optional[DesignVariableData] = Field(
        None, description='WING 1/4 CHORD SWEEP, DEG'
    )
    TCA: Optional[DesignVariableData] = Field(None, description='WING T/C')
    VCMN: Optional[DesignVariableData] = Field(None, description='CRUISE MACH NUMBER')
    CH: Optional[DesignVariableData] = Field(
        None, description='MAX CRUISE ALTITUDE, FT'
    )
    ETIT: Optional[DesignVariableData] = Field(
        None, description='TURBINE INLET TEMP (R)'
    )
    EOPR: Optional[DesignVariableData] = Field(
        None, description='OVERALL PRESSURE RATIO'
    )
    EFPR: Optional[DesignVariableData] = Field(None, description='FAN PRESSURE RATIO')
    EBPR: Optional[DesignVariableData] = Field(None, description='BYPASS RATIO')
    ETTR: Optional[DesignVariableData] = Field(None, description='THROTTLE RATIO')
    EBLA: Optional[DesignVariableData] = Field(
        None, description='PROPELLER BLADE ANGLE'
    )
    VARTH: Optional[DesignVariableData] = Field(
        None, description='TAKEOFF THRUST FACTOR'
    )
    ROTVEL: Optional[DesignVariableData] = Field(None, description='ROTATION VELOCITY')
    PLR: Optional[DesignVariableData] = Field(
        None, description='THRUST FRACTION AFTER PROGRAMMED LAPSE RATE'
    )


class OutputAerodynamicData(BaseModel):
    class Config:
        extra = Extra.forbid

    MACH_NUMBER: Optional[float] = Field(None, description='MACH NUMBER')
    ALTITUDE: Optional[float] = Field(None, description='ALTITUDE [FT]')
    REFERENCE_AREA: Optional[float] = Field(None, description='REFERENCE AREA [SQ FT]')
    TECHNOLOGY_LEVEL: Optional[float] = Field(None, description='TECHNOLOGY LEVEL')
    COMPONENT_DRAG_DATA: Optional[List[ComponentDragData]] = Field(
        None, description='COMPONENT DRAG DATA'
    )
    CHANGE_IN_DRAG_COEFFICIENT: Optional[ChangeDragCoefficient] = Field(
        None, description='COMPONENT DRAG DATA'
    )
    DRAG_POLARS: Optional[List[DragPolar]] = Field(
        None, description='COMPONENT DRAG DATA'
    )
    DESIGN_MACH_NUMBER: Optional[float] = Field(None, description='DESIGN MACH NUMBER')
    DESIGN_CL: Optional[float] = Field(None, description='DESIGN CL')
    MACH: Optional[List[float]] = Field(None, description='MACH')
    CDF: Optional[List[float]] = Field(None, description='CDF')
    CDC: Optional[List[float]] = Field(None, description='CDC')
    BUFFET_CL: Optional[List[float]] = Field(None, description='BUFFET CL')
    CL: Optional[List[float]] = Field(None, description='CL')
    CDI: Optional[List[float]] = Field(None, description='CDI')
    PRESSURE_DRAG_COEFFICIENTS: Optional[PressureDrag] = Field(
        None, description='PRESSURE DRAG COEFFICIENTS'
    )


class CruiseOptimizationResult(BaseModel):
    class Config:
        extra = Extra.forbid

    SCHEDULE_NUMBER: Optional[int] = Field(None, description='SCHEDULE NUMBER')
    ITERATION_NUMBER: Optional[int] = Field(None, description='ITERATION NUMBER')
    RANGE: Optional[float] = Field(None, description='RANGE')
    GROSS_WEIGTH: Optional[float] = Field(None, description='GROSS WEIGTH')
    ENERGY_USED: Optional[float] = Field(None, description='ENERGY USED')
    CAPACITY: Optional[float] = Field(None, description='CAPACITY')
    SUMMARY_DATA: Optional[CruiseSummaryData] = Field(
        None, description='SUMMARY DATA FOR CRUISE SCHEDULE'
    )
    RANGE_TIME_SUMMARY: Optional[RangeTimeSummaryData] = Field(
        None, description='RANGE AND TIME SUMMARY FOR CRUISE SCHEDULES'
    )


class OutputWeightData(BaseModel):
    class Config:
        extra = Extra.forbid

    WING_BENDING_FACTOR: Optional[float] = Field(
        None, description='WING BENDING FACTOR [None]'
    )
    ENGINE_INERTIA_RELIEF_FACTOR: Optional[float] = Field(
        None, description='ENGINE INERTIA RELIEF FACTOR [None]'
    )
    WING_WEIGHT_BREAKDOWN_TERM_1: Optional[float] = Field(
        None, description='WING WEIGHT BREAKDOWN TERM 1 [LB]\n            '
    )
    WING_WEIGHT_BREAKDOWN_TERM_2: Optional[float] = Field(
        None, description='WING WEIGHT BREAKDOWN TERM 2 [LB]\n            '
    )
    WING_WEIGHT_BREAKDOWN_TERM_3: Optional[float] = Field(
        None, description='WING WEIGHT BREAKDOWN TERM 3 [LB]\n            '
    )
    WING_SPAN: Optional[float] = Field(None, description='WING SPAN [FT]')
    WING_GLOVE_AREA: Optional[float] = Field(
        None, description='WING GLOVE AREA [SQ FT]'
    )
    HORIZONTAL_TAIL_AREA: Optional[float] = Field(
        None, description='HORIZONTAL TAIL AREA [SQ FT]'
    )
    HORIZONTAL_TAIL_AREA_MODIFIED_VOLUME_COEFFICIENT: Optional[float] = Field(
        None, description='HORIZONTAL TAIL AREA MODIFIED VOLUME COEFFICIENT [None]'
    )
    VERTICAL_TAIL_AREA: Optional[float] = Field(
        None, description='VERTICAL TAIL AREA [SQ FT]'
    )
    VERTICAL_TAIL_AREA_MODIFIED_VOLUME_COEFFICIENT: Optional[float] = Field(
        None, description='VERTICAL TAIL AREA MODIFIED VOLUME COEFFICIENT [None]'
    )
    NACELLE_LENGTH: Optional[float] = Field(None, description='NACELLE LENGTH [FT]')
    NACELLE_DIAMETER: Optional[float] = Field(None, description='NACELLE DIAMETER [FT]')
    LENGTH_OF_MAIN_GEAR: Optional[float] = Field(
        None, description='LENGTH OF MAIN GEAR [IN]'
    )
    LENGTH_OF_NOSE_GEAR: Optional[float] = Field(
        None, description='LENGTH OF NOSE GEAR [IN]'
    )
    MAXIMUM_LANDING_WEIGHT: Optional[float] = Field(
        None, description='MAXIMUM LANDING WEIGHT [LB]'
    )
    WING_FUEL_CAPACITY: Optional[float] = Field(
        None, description='WING FUEL CAPACITY [LB]'
    )
    FUSELAGE_FUEL_CAPACITY: Optional[float] = Field(
        None, description='FUSELAGE FUEL CAPACITY [LB]'
    )
    AUXILIARY_TANK_CAPACITY: Optional[float] = Field(
        None, description='AUXILIARY TANK CAPACITY [LB]'
    )
    TOTAL_FUEL_CAPACITY: Optional[float] = Field(
        None, description='TOTAL FUEL CAPACITY [LB]'
    )
    EXCESS_FUEL_CAPACITY: Optional[float] = Field(
        None, description='EXCESS FUEL CAPACITY [LB]'
    )
    MASS_AND_BALANCE_SUMMARY: Optional[List[MassAndBalanceSummaryComponent]] = Field(
        None, description='MASS AND BALANCE SUMMARY'
    )


class NoncruiseSegmentResults(BaseModel):
    class Config:
        extra = Extra.forbid

    PROFILES: Optional[List[NonCruiseProfileData]] = Field(None, description='PROFILES')
    ITERATION_NUMBER: Optional[int] = Field(None, description='ITERATION NUMBER')
    RANGE: Optional[float] = Field(None, description='RANGE')
    GROSS_WEIGTH: Optional[float] = Field(None, description='GROSS WEIGTH')
    ENERGY_USED: Optional[float] = Field(None, description='ENERGY USED')
    CAPACITY: Optional[float] = Field(None, description='CAPACITY')


class MissionSummary(BaseModel):
    class Config:
        extra = Extra.forbid

    SEGMENTS: Optional[List[MissionSummarySegment]] = Field(
        None, description='SEGMENTS'
    )
    DESIGN_RANGE: Optional[float] = Field(None, description='DESIGN RANGE [NM]')
    FLIGHT_TIME: Optional[float] = Field(None, description='FLIGHT TIME [MIN]')
    BLOCK_TIME: Optional[float] = Field(None, description='BLOCK TIME [HR]')
    BLOCK_FUEL: Optional[float] = Field(None, description='BLOCK FUEL [LB]')
    TOTAL_NITROGEN_OXIDES_EMISSIONS: Optional[float] = Field(
        None, description='TOTAL NITROGEN OXIDES EMISSIONS [LB]'
    )
    ATA_TRAFFIC_ALLOWANCE: Optional[float] = Field(
        None, description='ATA TRAFFIC ALLOWANCE [NM]'
    )
    AIR_MANEUVER: Optional[float] = Field(None, description='AIR MANEUVER [NM]')
    AIRPORT_TRAFFIC_ALLOWANCE: Optional[float] = Field(
        None, description='AIRPORT TRAFFIC ALLOWANCE [NM]'
    )
    AIRWAY_DISTANCE_FACTOR: Optional[float] = Field(
        None, description='AIRWAY DISTANCE FACTOR [NM]'
    )
    ATA_RANGE: Optional[float] = Field(None, description='ATA RANGE [NM]')


class DetailedFlightSegmentSummary(BaseModel):
    class Config:
        extra = Extra.forbid

    SEGMENTS: Optional[List[SegmentData]] = Field(None, description='SEGMENTS')


class LandingData(BaseModel):
    class Config:
        extra = Extra.forbid

    TIME: Optional[List[float]] = Field(None, description='TIME')
    DISTANCE: Optional[List[float]] = Field(None, description='DISTANCE')
    ALTITUDE: Optional[List[float]] = Field(None, description='ALTITUDE')
    VELOCITY: Optional[List[float]] = Field(None, description='VELOCITY')
    MACH: Optional[List[float]] = Field(None, description='MACH')
    GLIDE_SLOPE: Optional[List[float]] = Field(None, description='CLIMB ANGLE')
    ATTACK_ANGLE: Optional[List[float]] = Field(None, description='ATTACK ANGLE')
    ENGINE_INCIDENCE: Optional[List[float]] = Field(
        None, description='ENGINE INCIDENCE'
    )
    ENGINE_THRUST: Optional[List[float]] = Field(None, description='ENGINE THRUST')
    LIFT_COEFFICIENT: Optional[List[float]] = Field(
        None, description='LIFT COEFFICIENT'
    )
    DRAG_COEFFICIENT: Optional[List[float]] = Field(
        None, description='DRAG COEFFICIENT'
    )
    L_D: Optional[List[float]] = Field(None, description='L/D')
    DECELERATION: Optional[List[float]] = Field(None, description='ACCELERATION')
    POINTS: Optional[List[LandingPoint]] = Field(None, description='ENGINE')
    FLIGHT_PATH_SLOPE: Optional[float] = Field(None, description='FLIGHT PATH SLOPE')
    NET_THRUST: Optional[float] = Field(None, description='NET THRUST')


class AbortedTakeoffData(TakeoffData):
    POINTS: Optional[List[AbortedTakeoffPoint]] = Field(None, description='ENGINE')


class OneEngineOutTakeoffData(TakeoffData):
    POINTS: Optional[List[TakeoffPoint]] = Field(None, description='ENGINE')
    FLIGHT_PATH_SLOPE: Optional[float] = Field(
        None, description='FLIGHT PATH SLOPE (%)'
    )
    NET_THRUST: Optional[float] = Field(None, description='NET THRUST (LB)')


class SizingAndPerformanceResults(BaseModel):
    class Config:
        extra = Extra.forbid

    CONFIGURATION_DATA_AFTER_RESIZING: Optional[ConfigurationDataAfterResizing] = Field(
        None, description='CONFIGURATION DATA AFTER RESIZING (IF ANY)'
    )
    MISSION_SUMMARY: Optional[MissionSummary] = Field(
        None, description='* * *  MISSION SUMMARY  * * *'
    )


class LandingPerformanceResults(BaseModel):
    class Config:
        extra = Extra.forbid

    ANGLE_OF_ATTACK: Optional[List[float]] = Field(None, description='ANGLE OF ATTACK')
    LIFT_COEFFICIENT: Optional[List[float]] = Field(
        None, description='LIFT COEFFICIENT'
    )
    DRAG_COEFFICIENT: Optional[List[float]] = Field(
        None, description='DRAG COEFFICIENT'
    )
    CDMLD: Optional[float] = Field(None, description='CDMTO')
    CDGEAR: Optional[float] = Field(None, description='CDGEAR')
    CDEOUT: Optional[float] = Field(None, description='CDEOUT')
    CLLDM: Optional[float] = Field(None, description='CLTOM')
    LANDING_WEIGHT: Optional[float] = Field(None, description='TAKEOFF WEIGHT')
    VELOCITY: Optional[List[float]] = Field(None, description='VELOCITY')
    THRUST: Optional[List[float]] = Field(None, description='THRUST')
    LANDING_DATA: Optional[LandingData] = Field(None, description='LANDING DATA')
    Empty: Optional[LandingPerformanceResults] = Field(None, description='Empty')


class TakeoffPerformanceResults(BaseModel):
    class Config:
        extra = Extra.forbid

    ANGLE_OF_ATTACK: Optional[List[float]] = Field(None, description='ANGLE OF ATTACK')
    LIFT_COEFFICIENT: Optional[List[float]] = Field(
        None, description='LIFT COEFFICIENT'
    )
    DRAG_COEFFICIENT: Optional[List[float]] = Field(
        None, description='DRAG COEFFICIENT'
    )
    CDMTO: Optional[float] = Field(None, description='CDMTO')
    CDGEAR: Optional[float] = Field(None, description='CDGEAR')
    CDEOUT: Optional[float] = Field(None, description='CDEOUT')
    CLTOM: Optional[float] = Field(None, description='CLTOM')
    TAKEOFF_WEIGHT: Optional[float] = Field(None, description='TAKEOFF WEIGHT')
    VELOCITY: Optional[List[float]] = Field(None, description='VELOCITY')
    THRUST: Optional[List[float]] = Field(None, description='THRUST')
    ABORTED_TAKEOFF_ALL_ENGINES_OPERATING: Optional[AbortedTakeoffData] = Field(
        None, description='ABORTED TAKEOFF - ALL ENGINES OPERATING'
    )
    ABORTED_TAKEOFF_ONE_ENGINE_OUT: Optional[AbortedTakeoffData] = Field(
        None, description='ABORTED TAKEOFF - ONE ENGINE OUT'
    )
    ONE_ENGINE_OUT_TAKEOFF: Optional[OneEngineOutTakeoffData] = Field(
        None, description='ONE ENGINE OUT TAKEOFF'
    )
    ALL_ENGINES_OPERATING_TAKEOFF: Optional[AllEnginesOperativeTakeoffData] = Field(
        None, description='ALL ENGINES OPERATING TAKEOFF'
    )


class MissionRun(BaseModel):
    class Config:
        extra = Extra.forbid

    NONCRUISE_SEGMENT_RESULTS: Optional[NoncruiseSegmentResults] = Field(
        None, description='NONCRUISE SEGMENT RESULTS'
    )
    SIZING_AND_PERFORMANCE_RESULTS: Optional[SizingAndPerformanceResults] = Field(
        None, description='SIZING AND PERFORMANCE RESULTS'
    )
    DETAILED_FLIGHT_SEGMENT_SUMMARY: Optional[DetailedFlightSegmentSummary] = Field(
        None, description='DETAILED FLIGHT SEGMENT SUMMARY'
    )


class FLOPSOutput(BaseModel):
    class Config:
        extra = Extra.ignore

    TITLE: str = Field(
        ..., description='Any alphanumeric title. Maximum length 80'
    )
    OPTION: OutputOptionNamelist = Field(
        ..., description='Program Control, Execution, Analysis and Plot Option Data'
    )
    WTIN: OutputWtinNamelist = Field(
        ..., description='Geometric, Weight, Balance and Inertia Data (Required)'
    )
    CONFIN: OutputConfinNamelist = Field(
        ...,
        description='Configuration Geometric Ratios, Objective Function Definition, \nand Design Variables (Required)',
    )
    AERIN: OutputAerinNamelist = Field(
        ...,
        description='Aerodynamic Input Options and Data for Internal Aerodynamic\nCalculations and Approximate Takeoff and Landing (Required)',
    )
    ENGDIN: OutputEngdinNamelist = Field(
        ..., description='Engine Deck Control, Scaling and Usage Data'
    )
    ALL_POINT_ENGINE_DECK_SUMMARY: Optional[List[PointEngineDeckSummary]] = Field(
        None, description='All Point Engine Deck Summary'
    )
    MISSIN: Optional[OutputMissinNamelist] = Field(
        None,
        description='Performance Controls and Factors and Mission Segment Definition ',
    )
    TOLIN: Optional[OutputTolinNamelist] = Field(
        None,
        description='Detailed Takeoff and Landing Data \n(Used only if ITAKOF, ILAND and/or NOPRO = 1 in Namelist $OPTION)',
    )
    AERODYNAMIC_DATA: Optional[OutputAerodynamicData] = Field(
        None, description='AERODYNAMIC DATA'
    )
    CRUISE_OPTIMIZATION_RESULTS: Optional[List[CruiseOptimizationResult]] = Field(
        None, description='CRUISE OPTIMIZATION RESULTS'
    )
    OUTPUT_FROM_THE_WEIGHTS_MODULE: Optional[OutputWeightData] = Field(
        None, description='OUTPUT FROM THE WEIGHTS MODULE DATA'
    )
    MISSION_RUNS: Optional[List[MissionRun]] = Field(
        None, description='Mission results for different range values'
    )
    LANDING_PERFORMANCE_RESULTS: Optional[LandingPerformanceResults] = Field(
        None, description='LANDING PERFORMANCE RESULTS'
    )
    TAKEOFF_PERFORMANCE_RESULTS: Optional[TakeoffPerformanceResults] = Field(
        None, description='TAKEOFF PERFORMANCE RESULTS'
    )
    OBJ_VAR_CONSTR_SUMMARY: Optional[ObjVarConstrSummary] = Field(
        None, description='OBJ/VAR/CONSTR SUMMARY'
    )
    FailedRunOutput: Optional[FLOPSOutput] = Field(
        None, description='Return a failed run oputput'
    )


LandingPerformanceResults.update_forward_refs()
FLOPSOutput.update_forward_refs()
